package com.adc.da.util;


import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * 调用 WebService 接口工具类
 *
 * @author David
 */
@Component
public class SoapUtils {
    private static final Logger logger = LoggerFactory.getLogger(SoapUtils.class);


//    @Autowired
//    private ICheckCommunicationLogService xxService;

//    @Autowired
//    private  RestTemplate restTemplate;


//    private static ICheckCommunicationLogService service;
//
//    public @PostConstruct void init() {
//        setService(xxService);
//    }
//
//    private void setService(ICheckCommunicationLogService  xxService) {
//        setStaticService(xxService);
//    }
//
//    private synchronized static void  setStaticService(ICheckCommunicationLogService xxService) {
//        SoapUtils.service = xxService;
//    }

    /**
     * 请求wsdl接口
     *
     * @param method 方法名称
     * @param params 参数map 此处必须传递LinkedHashMap，保证传入参数的顺序
     * @return xml对应的map
     */
//    public String requestWsdl(String endpoint, String method, String params,int number) {
//        try {
//            URL url = new URL(endpoint);
//            HttpURLConnection con = (HttpURLConnection) url.openConnection();
//            con.setDoInput(true);
//            con.setDoOutput(true);
//            con.setConnectTimeout(30*60*1000);
//            con.setRequestMethod("POST");
//            con.setRequestProperty("Content-Type", "text/xml;charset=UTF-8");
//            OutputStream oStream = con.getOutputStream();
//            //下面这行代码是用字符串拼出要发送的xml，xml的内容是从测试软件里拷贝出来的
//            //需要注意的是，有些空格不要弄丢哦，要不然会报500错误的。
//            //参数什么的，你可以封装一下方法，自动生成对应的xml脚本
//            String encryCode =
//                    "encryCode";
//            String soap = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" " +
//                    "xmlns:ggc=\"http://www.catarc.info/ggcert\">" +
//                    "    <soapenv:Header>" +
//                    "    <soapenv:Body>" +
//                    "        <ggc:" + method + "><" + encryCode + ">" + params + "</" + encryCode + ">        " +
//                    "</ggc:" + method +
//                    ">" +
//                    "    </soapenv:Body>" +
//                    "</soapenv:Envelope>";
//            oStream.write(soap.getBytes());
//            oStream.close();
//            if (con.getResponseCode() == 500 && number < 10) {
//                return number + "";
//            } else if (con.getResponseCode() == 500){
//                logger.error("调用webService接口错误");
//                return "失败";
//            }
//            InputStream iStream = con.getInputStream();
//            Reader reader = new InputStreamReader(iStream);
//
//            int tempChar;
//            StringBuilder str = new StringBuilder();
//            while ((tempChar = reader.read()) != -1) {
//                str.append((char) tempChar);
//            }
//
//            String aa = "";
//            aa = XmlUtils.xmlToMap(str.toString(), "utf-8");
//            iStream.close();
//            oStream.close();
//            con.disconnect();
//            return "spiderEnvInfoForEncrypt".equals(method)? aa :AES256.decrypt(aa.replace(" ", ""),"1234567890123456");
//        } catch (Exception e) {
//            logger.error(e.getMessage());
//        }
//        return "";
//    }

    public static List<Map<String, String>> requestWsdlOld(String endpoint, String method, LinkedHashMap<String, Object> params, RestTemplate restTemplate) {
            try {

                HttpHeaders headers = new HttpHeaders();
                MediaType type = MediaType.parseMediaType("text/xml;charset=UTF-8");
                headers.setContentType(type);

//                URL url = new URL(endpoint);
//                HttpURLConnection con = (HttpURLConnection) url.openConnection();
//                con.setDoInput(true);
//                con.setDoOutput(true);
//                con.setRequestMethod("POST");
//                con.setRequestProperty("Content-Type", "text/xml;charset=UTF-8");
//                OutputStream oStream = con.getOutputStream();
                //下面这行代码是用字符串拼出要发送的xml，xml的内容是从测试软件里拷贝出来的
                //需要注意的是，有些空格不要弄丢哦，要不然会报500错误的。
                //参数什么的，你可以封装一下方法，自动生成对应的xml脚本
                String paramStr = "";
                String soap = "<soapenv:Envelope xmlns:xsi=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\">" +
                        "    <soapenv:Body>" +
                        "        <" + method + ">";
                for (Map.Entry<String, Object> entry : params.entrySet()) {
                    paramStr += "<" + entry.getKey() + ">" + entry.getValue() + "</" + entry.getKey() + ">";
                }
                soap += paramStr;
                soap += "        </" + method + ">" +
                        "    </soapenv:Body>" +
                        "</soapenv:Envelope>";
//                oStream.write(soap.getBytes());
//                oStream.close();
                logger.error(soap);
                HttpEntity<String> formEntity = new HttpEntity<String>(soap, headers);
                SimpleClientHttpRequestFactory simpleClientHttpRequestFactory =new SimpleClientHttpRequestFactory();
                simpleClientHttpRequestFactory.setConnectTimeout(300000);
                simpleClientHttpRequestFactory.setReadTimeout(300000);

//                restTemplate.setRequestFactory(simpleClientHttpRequestFactory);
                restTemplate = new RestTemplate(simpleClientHttpRequestFactory);
                String str = restTemplate.postForObject(endpoint, formEntity, String.class);
               String newStr = str.replace("&nbsp;","&#160;");
                List resultList;
                if (method.equals("getCdVehicleParams")){
                    resultList = XmlUtils.getCdVehicleParams(newStr.toString(), "utf-8");
                } else {
                    resultList = XmlUtils.xmlToMapOld(newStr.toString(), "utf-8");
                }
//                iStream.close();
//                oStream.close();
//                con.disconnect();
                return resultList;
            } catch (Exception e) {
//                logger.error(e.getMessage());
                e.printStackTrace();
//                service.save(new CheckCommunicationLog()
//                        .setId(UUIDUtils.getUUID())
//                        .setLogResult("失败")
//                        .setLogType("公告环保同步接口")
//                        .setLogTime(new Date()));
                logger.error("调用webService接口错误");
            }
            return new ArrayList<>();
        }
}
