package com.adc.da.util;

/**
 * 去除字符串中不是汉字的字符
 */
public class StringManipulation {
    private StringManipulation() {
    }

    /**
     * 去掉字符串中不是汉字的字符
     * @param str
     * @return
     */
    public static String getStringManipulation(String str){
        int index = getFirstChineseFont(str);
        String code = str.substring(0, index);
        String[] arr = str.split(code);
        String finalStr = arr[arr.length - 1];
        if(finalStr.endsWith("_")) {
            finalStr = finalStr.substring(0, finalStr.length() - 1);
        }
        return finalStr;
    }

    /**
     * 获取第一个汉字的位置
     * @param s
     * @return
     */
    private static int getFirstChineseFont(String s) {
        //找第一个汉字
        for (int index = 0;index<=s.length()-1;index++){
            //将字符串拆开成单个的字符
            String w=s.substring(index, index+1);
            // \u4e00-\u9fa5 中文汉字的范围
            if(w.compareTo("\u4e00")>0&&w.compareTo("\u9fa5")<0){
                return index;
            }
        }
        return 0;
    }

}
