package com.adc.da.util;

import com.tencentcloudapi.common.Credential;
import com.tencentcloudapi.common.exception.TencentCloudSDKException;
import com.tencentcloudapi.common.profile.ClientProfile;
import com.tencentcloudapi.common.profile.HttpProfile;
import com.tencentcloudapi.ocr.v20181119.OcrClient;
import com.tencentcloudapi.ocr.v20181119.models.GeneralAccurateOCRRequest;
import com.tencentcloudapi.ocr.v20181119.models.GeneralAccurateOCRResponse;
import com.tencentcloudapi.ocr.v20181119.models.TextDetection;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.Map;

@Component
public class TengXunOCRUtils {

    @Value("${tencent.secretId}")
    private String secretId;

    @Value("${tencent.secretKey}")
    private String secretKey;

    private static final Logger logger = LoggerFactory.getLogger(TengXunOCRUtils.class);

    public static void main(String [] args) {
        try{

            Credential cred = new Credential("AKIDKSO1Vc2uIJ5br09GzSgZCYnunOk0FUqx", "3pUlpbFWcUAYidJiz1oLdleMtDQTCmfJ");

            HttpProfile httpProfile = new HttpProfile();
            httpProfile.setEndpoint("ocr.tencentcloudapi.com");

            ClientProfile clientProfile = new ClientProfile();
            clientProfile.setHttpProfile(httpProfile);

            OcrClient client = new OcrClient(cred, "ap-beijing", clientProfile);

            String fileBase64 = FileUtil.encodeBase64File("C:\\Users\\26635\\Desktop\\铭牌\\长城N类\\IMG20190925134024.jpg");
            String params = "{\"ImageBase64\":\"" + fileBase64 + "\"}";
            GeneralAccurateOCRRequest req = GeneralAccurateOCRRequest.fromJsonString(params, GeneralAccurateOCRRequest.class);

            GeneralAccurateOCRResponse resp = client.GeneralAccurateOCR(req);

            TextDetection[] result = resp.getTextDetections();
            StringBuilder nameplate = new StringBuilder();
            for(TextDetection textDetection : result){
                nameplate.append(textDetection.getDetectedText());
            }

            System.out.println(GeneralAccurateOCRRequest.toJsonString(resp));
            System.out.println(nameplate);
        } catch (TencentCloudSDKException e) {
            System.out.println(e.toString());
        }

    }

    public Map<String,String> orc(String path) {
        try{

            Credential cred = new Credential(secretId, secretKey);

            HttpProfile httpProfile = new HttpProfile();
            httpProfile.setEndpoint("ocr.tencentcloudapi.com");

            ClientProfile clientProfile = new ClientProfile();
            clientProfile.setHttpProfile(httpProfile);

            OcrClient client = new OcrClient(cred, "ap-beijing", clientProfile);

            String fileBase64 = FileUtil.encodeBase64File(path);
            String params = "{\"ImageBase64\":\"" + fileBase64 + "\"}";
            GeneralAccurateOCRRequest req = GeneralAccurateOCRRequest.fromJsonString(params, GeneralAccurateOCRRequest.class);

            GeneralAccurateOCRResponse resp = client.GeneralAccurateOCR(req);

            TextDetection[] result = resp.getTextDetections();
            StringBuilder nameplate = new StringBuilder();
            for(TextDetection textDetection : result){
                nameplate.append(textDetection.getDetectedText());
            }
            Map<String,String> map = new HashMap<>();
            map.put("result", nameplate.toString());
            return map;
        } catch (Exception e) {
            logger.error("图片识别失败");
            return null;
        }
    }
}
