package com.adc.da.util;

import com.adc.da.util.http.ResponseMessage;
import com.adc.da.util.http.Result;
import org.apache.commons.io.FileUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * 暂存文件工具
 */
@RestController
@RequestMapping("/api")
public class UploadUtils {

    private static final Logger logger = LoggerFactory.getLogger(UploadUtils.class);

    @Value("${uploadFile}")
    private    String uploadFile;
    @Value("${sibieImg}")
    private  String sibieImg;

//    public static String getSibieImg() {
//        return sibieImg;
//    }
//    @Value("${sibieImg}")
//    public void setSibieImg(String sibieImg) {
//        UploadUtils.sibieImg = sibieImg;
//    }

//    private static String uploadFile;

//    public static String getUploadFile() {
//        return sibieImg;
//    }
//    @Value("${uploadFile}")
//    public void setUploadFile(String uploadFile) {
//        UploadUtils.uploadFile = uploadFile;}
    /**
     * 文件上传
     * @param file
     * @param id
     * @return
     */
    @PostMapping("/upload")
    public ResponseMessage upload(MultipartFile file, String id) {
        //获取文件名
        String fileName = file.getOriginalFilename();
        //获取文件后缀名
        String suffixName = fileName.substring(fileName.lastIndexOf("."));
        //重新生成文件名
        fileName = UUIDUtils.getUUID() + suffixName;
        //指定本地文件夹存储图片
        String filePath = "carAndKey/";
        String SfilePath = uploadFile+filePath;
        File dir = new File(SfilePath);
        if (!dir.exists()) {
            dir.mkdirs();
        }
        try {
            FileUtils.copyInputStreamToFile(file.getInputStream(), new File(SfilePath + fileName));
        } catch (IOException e) {
            return Result.error("-1", "文件暂存失败");
        }
        Map<String, Object> map = new HashMap<>();
        map.put("id",id);
        map.put("path",filePath + fileName);
        return Result.success("200", "文件暂存成功", map);
    }
    /**
     * 文件上传
     * @param file
     * @return
     */
    public  String uploadFile(MultipartFile file) {
        //获取文件名
        String fileName = file.getOriginalFilename();
        //获取文件后缀名
        String suffixName = fileName.substring(fileName.lastIndexOf("."));
        //重新生成文件名
        fileName = UUIDUtils.getUUID() + suffixName;
        //指定本地文件夹存储图片
        String filePath = sibieImg;
        File dir = new File(filePath);
        if (!dir.exists()) {
            dir.mkdirs();
        }
        try {
            file.transferTo(new File(filePath + fileName));
        } catch (IOException e) {
            logger.error("文件上传失败");
            return "-1";
        }
        return filePath + fileName;
    }
}
