package com.adc.da.util;

import com.adc.da.system.entity.CheckBulletinDataParameter;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.ByteArrayInputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * xml 工具类
 */
public class XmlUtils {

    /**
     * 私有构造方法
     */
    private XmlUtils() {
    }

    /**
     * xml字符串转map
     *
     * @param xml
     * @param charset
     * @return
     * @throws UnsupportedEncodingException
     * @throws DocumentException
     */
    public static String xmlToMap(String xml, String charset) throws UnsupportedEncodingException, DocumentException {

        SAXReader reader = new SAXReader();
        Document doc = reader.read(new ByteArrayInputStream(xml.getBytes(charset)));
        Element root = doc.getRootElement();
        return root.elements().get(0).elements().get(0).elements().get(0).getTextTrim();
    }

    /**
     * 设置list
     *
     * @param list
     * @param dataList
     * @param dataList
     */
    private static void setDateList(List<Element> list, List<Map<String, String>> dataList) {
        int index = list.size();
        for (int k = 0; k < index; k++) {
            Map<String, String> respMap = new HashMap<>();
            for (int j = 0; j < list.get(0).elements().size(); j++) {
                respMap.put(list.get(0).elements().get(j).getName(), list.get(0).elements().get(j).getTextTrim());
            }
            list.remove(0);
            dataList.add(respMap);
        }
    }

    public static List<Map<String, String>> xmlToMapOld(String xml, String charset) throws UnsupportedEncodingException, DocumentException {

        Map<String, String> respMap = new HashMap<>();
        List<Map<String, String>> dataList = new ArrayList<>();
        SAXReader reader = new SAXReader();
        Document doc = reader.read(new ByteArrayInputStream(xml.getBytes(charset)));
        Element root = doc.getRootElement();
        int num = 0;
        xmlToMapOld(root, respMap, dataList, num);
        return dataList;
    }
    public static List getCdVehicleParams(String xml, String utf) throws UnsupportedEncodingException, DocumentException {
        SAXReader reader = new SAXReader();
        Document doc = reader.read(new ByteArrayInputStream(xml.getBytes(utf)));
        Element root = doc.getRootElement();
        List<List<CheckBulletinDataParameter>> resultList = new ArrayList<>();
        List<CheckBulletinDataParameter> parameterList = new ArrayList<>();
        List<CheckBulletinDataParameter> regParameterList = new ArrayList<>();
        int num = 0;
        getCdVehicleParams(root, parameterList, regParameterList, num);
        resultList.add(parameterList);
        resultList.add(regParameterList);
        return resultList;
    }
    private static void getCdVehicleParams(Element tmpElement, List<CheckBulletinDataParameter> dataList, List<CheckBulletinDataParameter> regParameterList, int num) {
        if (tmpElement.elements() != null) {
            //如果当前跟节点有子节点，找到子节点
            List<Element> list = tmpElement.elements();
            //遍历每个节点
            for (int i = 0; i < list.size(); i++) {
                if (!list.get(i).elements().isEmpty()) {
                    num++;
//                    if (num == 3) {
//                        int index = list.size();
//                        for (int k = 0; k < index; k++) {
//
//                        }
//                    }
                    if (num == 4) {
                        int index = list.size();
                        String name = "";
                        for (int k = 0; k < index; k++) {
                            CheckBulletinDataParameter checkBulletinDataParameter = new CheckBulletinDataParameter();
                            for (int j = 0; j < list.get(0).elements().size(); j++) {
                                if (list.get(0).elements().get(j).getName().equals("seq")) {
                                    checkBulletinDataParameter.setSeq(list.get(0).elements().get(j).getTextTrim());
                                }
                                if (list.get(0).elements().get(j).getName().equals("ename")) {
                                    checkBulletinDataParameter.setEName(list.get(0).elements().get(j).getTextTrim());
                                }
                                if (list.get(0).elements().get(j).getName().equals("name")) {
                                    checkBulletinDataParameter.setName(list.get(0).elements().get(j).getTextTrim());
                                }
                                if (list.get(0).elements().get(j).getName().equals("value")) {
                                    checkBulletinDataParameter.setValue(list.get(0).elements().get(j).getTextTrim());
                                }
                            }
                            CheckBulletinDataParameter checkBulletinDataParameter2 = new CheckBulletinDataParameter();
                            name += list.get(0).getName();
                            if (list.get(0).getName().equals("ggParams")) {
                                checkBulletinDataParameter.setParameterType("0");
                                dataList.add(checkBulletinDataParameter);
                            } else if (list.get(0).getName().equals("regParams")) {
                                checkBulletinDataParameter.setParameterType("1");
                                regParameterList.add(checkBulletinDataParameter);
                            } else if (list.get(0).getName().equals("hbzp")) {
                                checkBulletinDataParameter2.setName("后部照片");
                                checkBulletinDataParameter2.setValue(list.get(0).getTextTrim());
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);
                            } else if (list.get(0).getName().equals("pz_id")) {
                                checkBulletinDataParameter2.setName("双积分配置ID");
                                checkBulletinDataParameter2.setValue(list.get(0).getTextTrim());
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);

                            } else if (list.get(0).getName().equals("ybzp")) {
                                checkBulletinDataParameter2.setName("右部照片");
                                checkBulletinDataParameter2.setValue(list.get(0).getTextTrim());
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);
                            } else if (list.get(0).getName().equals("chfhzp")) {
                                checkBulletinDataParameter2.setName("侧、后下部防护装置的组合照片");
                                checkBulletinDataParameter2.setValue(list.get(0).getTextTrim());
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);
                            } else if (list.get(0).getName().equals("xzzp1")) {
                                checkBulletinDataParameter2.setName("选装部件1");
                                checkBulletinDataParameter2.setValue(list.get(0).getTextTrim());
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);
                            } else if (list.get(0).getName().equals("xzzp2")) {
                                checkBulletinDataParameter2.setName("选装部件2");
                                checkBulletinDataParameter2.setValue(list.get(0).getTextTrim());
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);
                            } else if (list.get(0).getName().equals("xzzp3")) {
                                checkBulletinDataParameter2.setName("选装部件3");
                                checkBulletinDataParameter2.setValue(list.get(0).getTextTrim());
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);
                            }
                            list.remove(0);
                        }
                        String [] nameArr = {"pz_id","hbzp","ybzp","chfhzp","xzzp1","xzzp2","xzzp3"};
                        String [] arr = {"双积分配置ID","后部照片","右部照片","侧、后下部防护装置的组合照片"
                                ,"选装部件1","选装部件2","选装部件3"};
                        for (int m = 0;m<nameArr.length;m++){
                            if (!name.contains(nameArr[m])) {
                                CheckBulletinDataParameter checkBulletinDataParameter2 = new CheckBulletinDataParameter();
                                checkBulletinDataParameter2.setName(arr[m]);
                                checkBulletinDataParameter2.setValue("");
                                checkBulletinDataParameter2.setParameterType("0");
                                dataList.add(checkBulletinDataParameter2);
                            }
                        }

                    } else {
                        //当前节点不为空的话，递归遍历子节点；
                        getCdVehicleParams(list.get(i), dataList, regParameterList, num);
                    }
                } else {
                    CheckBulletinDataParameter checkBulletinDataParameter = new CheckBulletinDataParameter();
                    if (list.get(i).getName().equals("seq")) {
                        checkBulletinDataParameter.setSeq(list.get(i).getTextTrim());
                    }
                    if (list.get(i).getName().equals("ename")) {
                        checkBulletinDataParameter.setEName(list.get(i).getTextTrim());
                    }
                    if (list.get(i).getName().equals("name")) {
                        checkBulletinDataParameter.setName(list.get(i).getTextTrim());
                    }
                    if (list.get(i).getName().equals("value")) {
                        checkBulletinDataParameter.setValue(list.get(i).getTextTrim());
                    }
                }
            }
        }
    }


    private static List<Map<String, String>> xmlToMapOld(Element tmpElement, Map<String, String> respMap, List<Map<String, String>> dataList, int num) {
        if (tmpElement.elements() != null) {
            //如果当前跟节点有子节点，找到子节点
            List<Element> list = tmpElement.elements();
            //遍历每个节点
            for (int i = 0; i < list.size(); i++) {
                if (!list.get(i).elements().isEmpty()) {
                    num++;
                    if (num == 3) {
                        setDateList(list, dataList);
                    } else {
                        //当前节点不为空的话，递归遍历子节点；
                        xmlToMapOld(list.get(i), respMap, dataList, num);
                    }
                } else {
                    respMap.put(list.get(i).getName(), list.get(i).getTextTrim());
                    dataList.add(respMap);
                }
            }
        }
        return dataList;
    }
}
